//
// Distributor.h
// LGDCommunicationKit Examples, Release 1.0 (prerelease)
//
// Copyright (c) 1993, Looking Glass Design, Inc.
// All rights reserved.
//
// Project Manager:  Paul Girone
// Original Author:  Mike Gobbi
// Creation Date:    June 10, 1993
// $Revision: 1.3 $
//

#import <objc/Object.h>

// the hangup function is called in response to a HUP signal
void hangup(void);
// the cleanup function is called in response to any one of
// the INT, QUIT, BUS, SEGV, TERM signals
void cleanup(void);

@interface Distributor:Object
{
	// objects
	id window;
	id serialPort;
	
	// configuration
	id devicePopup;
	id modeMatrix;
	id CRModSwitch;
	id duplexSwitch;
	
	// communication
	id inputField;
	id incomingField;
	id outgoingField;
	id sendButton;
	id pollButton;
	id peekButton;
	id byteSwitch;
	id autoPollSwitch;
}

// Status
- displayStatus:sender;

// Communication
- send:sender;
- poll:sender;
- peek:sender;
- clearTextFields:sender;

// Buffers
- flushInput:sender;
- flushOutput:sender;
- flushAll:sender;

// Settings
- takeCRModFrom:sender;
- takeDuplexFrom:sender;
- takeAutoPollFrom:sender;
- takeModeFrom:sender;

// Signals
- raiseDTR:sender;
- lowerDTR:sender;
- raiseBRK:sender;
- lowerBRK:sender;

// Application delegate methods
- appDidInit:anApplication;
- appWillTerminate:anApplication;

// SerialPort delegate methods
- serialPortWillOpen:aPort;
- serialPortDidOpen:aPort;
- serialPortDidClose:aPort;

// Archiving
- awakeFromNib;

@end
