//
// LGDAppSerialPort.h
// LGDCommunicationKit, Release 1.0 (prerelease)
//
// Copyright (c) 1993, Looking Glass Design, Inc.
// All rights reserved.
//
// Project Manager:  Paul Girone
// Original Author:  Mike Gobbi
// Creation Date:    June 9, 1993
// $Revision: 1.3 $
//

#import "LGDSerialPort.h"
#import <objc/HashTable.h>

@interface LGDAppSerialPort:LGDSerialPort
{
	// Outlets
	id			delegate;
	id			target;
	SEL			action;
}

// Factory methods
+ initialize;
- init;

// Outlets
- setDelegate:anObject;
- setTarget:anObject;
- setAction:(SEL)anAction;
- delegate;
- target;
- (SEL)action;

// Actions
- openAndLock:sender;
- unlockAndClose:sender;
- sendBreak:sender;
- sendDisconnect:sender;

// Connecting
- openWithTimeout:(long)seconds;
- close;

// Buffers
- portEvent;

// Archiving
- write:(NXTypedStream *)stream;
- read:(NXTypedStream *)stream;

@end

@interface Object(Delegate)

- serialPortWillOpen:sender;
- serialPortDidOpen:sender;
- serialPortWillClose:sender;
- serialPortDidClose:sender;
- serialPortWillDisconnect:sender;
- serialPortDidDisconnect:sender;

@end
