/*  
** Copyright (c) 1995 Netsurfer Inc.  All Rights Reserved.
**
** Author: <bbum@friday.com>
*/

/*  This object is included in the MiscKit by permission from the author
**  and its use is governed by the MiscKit license, found in the file
**  "LICENSE.rtf" in the MiscKit distribution.  Please refer to that file
**  for a list of all applicable permissions and restrictions.
*/

#import <jpeglib.h>

struct surfjpeg_error_mgr {
	struct jpeg_error_mgr pub;	// normal error handling fields
	jmp_buf setjmp_buffer;      // longjmp() return spot
};

struct surfjpeg_decompress_struct {
	struct jpeg_decompress_struct 	pub;			// normal decompress_struct
	id								jpegDecoder; 	// owning decoder
};

typedef struct surfjpeg_error_mgr 			*surfjpeg_error_ptr;
typedef struct surfjpeg_decompress_struct 	*surfjpeg_decompress_ptr;

@interface SurfJPEGDecoder : SurfDecoder
{
	struct surfjpeg_decompress_struct 	jpegDecompInfo;/*"jpeg decoder struct"*/
	struct surfjpeg_error_mgr 			jpegErrMgr;/*"jpeg error manager"*/
	unsigned							rowsRead;/*"rows read so far"*/
	unsigned							readCount;/*"# of rows to decode per pass (default 5)"*/
	unsigned							totalRows;/*"total rows in image"*/
	unsigned char 						**rowPtrBuf;/*"row decoding buffer"*/
}

/*"
 * Instantiation
"*/
+ sharedInstance;

/*"
 *  Class query
"*/
+ (const char *const *)imageUnfilteredFileTypes;
+ (BOOL)canLoadFromStream:(NXStream *)stream;

/*"
 * JPEG Custom Configuration
"*/
- (void) setReadCount: (unsigned) aNum;
- (unsigned) readCount;
@end
