.\" @(#)eni_init.l 1.0 22Sep91 McGill SOCS
.TH ENI_INIT L "22 September 1991"
.SH NAME
eni_init \- initialize the Ethernet front\-end interface
.SH SYNOPSIS
.nf
.B "#include <libeni.h>
.PP
.B int eni_init(void)
.fi
.SH DESCRIPTION
.I eni_init
initializes the front\-end to the Ethernet device driver.  It must be called
only once in a program, and before the other
.I eni
routines are called.
.SH "RETURN VALUES"
.I eni_init
returns 0 if it is successful, otherwise it returns \-1.  In the latter case
the external variable
.I eni_errno
is set to one of the following values:
.TP 15
[ENXIO]
Cannot connect to the loadable kernel module \- it is probably not loaded.
.TP 15
[EAGAIN]
.B eni_init
has already been called.
.TP 15
[ENOBUFS]
A necessary resource could not be allocated.
.TP 15
[ENOINIT]
The loadable kernel module could not be initialized.
.SH "SEE ALSO"
eni_get_packet(L), eni_send_packet(L)
.SH AUTHOR
Bill Heelan, McGill University SOCS
