/*
    Our message types.
*/

#define MSG_HAVE_PACKET	-1000
#define MSG_SEND_PACKET	-1001
#define MSG_RET_CODE	-1002
#define MSG_STATS	-1003
#define MSG_INIT	-1004


struct eni_stats
{
    int in_packets ;	    /* # successfully received packets */
    int out_packets ;	    /* # successfully output packets */
    int replies ;	    /* # msg replies sent to client */
    int lost_in_packets ;   /* failed in receiving a packet for the client */
    int lost_out_packets ;  /* failed to output a client packet */
} ;


struct eheader
{
    unsigned char daddr[6] ;
    unsigned short frame_type ;
    int data_length ;
} ;


/*
    The types of messages we know about.
*/

struct m_init
{
    msg_header_t head ;
} ;

struct m_packet	/* a packet */
{
    msg_header_t head ;
    msg_type_t type_1 ;
    struct eheader eh ;
    msg_type_t type_2 ;
    unsigned char data[ENI_MTU] ;
} ;

struct m_reply_ret_code	/* reply with a return code */
{
    msg_header_t head ;
    msg_type_t type ;
    int ret_code ;
} ;

struct m_reply_stats	/* reply with statistics */
{
    msg_header_t head ;
    msg_type_t type ;
    struct eni_stats stats ;
} ;
