/* Protocol for Objective-C objects that form a doubly linked list

   Copyright (C) 1993 R. Andrew McCallum <mccallum@cs.rochester.edu>
   Dept. of Computer Science, U. of Rochester, Rochester, NY  14627

   This file is part of the GNU Objective-C Collection library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

/* The <ListLinking> protocol defines the interface to an object
   that may be an element in a LinkList.  LinkList is a collection
   object based on a doubly linked list. 
*/

#ifndef __ListLinking_h_INCLUDE_GNU
#define __ListLinking_h_INCLUDE_GNU

@protocol ListLinking

// Accessing neighboring links in the list;
- (id <ListLinking>) nextLink;
- (id <ListLinking>) prevLink;

// Setting new neighbors in the list;
- setNextLink: (id <ListLinking>)aLink;
- setPrevLink: (id <ListLinking>)aLink;

@end

#endif /* __ListLinking_h_INCLUDE_GNU */
