/* Interface for Objective-C SortedArray collection object

   Copyright (C) 1993 R. Andrew McCallum <mccallum@cs.rochester.edu>
   Dept. of Computer Science, U. of Rochester, Rochester, NY  14627

   This file is part of the GNU Objective-C Collection library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

#ifndef __SortedArray_h_INCLUDE_GNU
#define __SortedArray_h_INCLUDE_GNU

#include <coll/Array.h>
#include <coll/ComparedCollecting.h>

@interface SortedArray : Array <ComparedCollecting>
{
  int (*_comparator)(elt,elt);
}

@end

#endif /* __SortedArray_h_INCLUDE_GNU */
