/* General purpose definitions for the Collection Library.

   Copyright (C) 1993 R. Andrew McCallum <mccallum@cs.rochester.edu>
   Dept. of Computer Science, U. of Rochester, Rochester, NY  14627

   This file is part of the GNU Objective-C Collection library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

#ifndef __collstd_h_INCLUDE_GNU
#define __collstd_h_INCLUDE_GNU

#include <objc/hash.h>
#include <objc/Object.h>

/* I'd like this memory allocation stuff to be put somewhere more general. */

/* I do this to make substituting Boehm's GC easy. 
   Perhaps I should others too, like objc_atomic_malloc(), etc. */
extern void *(*objc_malloc)(size_t);
extern void *(*objc_realloc)(void *, size_t);
extern void *(*objc_calloc)(unsigned, size_t);
extern void (*objc_free)(void *);

#define  OBJC_MALLOC(VAR, TYPE, NUM) \
   ((VAR) = (TYPE *) (*objc_malloc)((unsigned)(NUM)*sizeof(TYPE))) 
#define  OBJC_REALLOC(VAR, TYPE, NUM) \
   ((VAR) = (TYPE *) (*objc_realloc)((VAR), (unsigned)(NUM)*sizeof(TYPE)))
#define  OBJC_CALLOC(VAR, TYPE, NUM) \
   ((VAR) = (TYPE *) (*objc_calloc)((unsigned)(NUM), sizeof(TYPE)))
#define  OBJC_FREE(PTR) (*objc_free)((PTR))


/* Eventually I'd like this to be added to hash.h */
extern node_ptr hash_node_for_key (cache_ptr cache, const void *key);

/* I'd like this to be made public. */
extern int objc_sizeof_type(const char* type);

/* I'd like this to be added to Object */
@interface Object (shouldNotImplement)
- shouldNotImplement: (SEL)aSel;
@end

#endif /* __collstd_h_INCLUDE_GNU */
