/* Implementation for Objective-C SplayTree collection object
   Copyright (C) 1993 Free Software Foundation, Inc.

   Written by:  R. Andrew McCallum <mccallum@cs.rochester.edu>
   Dept. of Computer Science, U. of Rochester, Rochester, NY  14627

   This file is part of the GNU Objective-C Collection library.

   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License as published by the Free Software Foundation; either
   version 2 of the License, or (at your option) any later version.
   
   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public
   License along with this library; if not, write to the Free
   Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/ 

#include <coll/SplayTree.h>
#include <coll/IndexedCollectionPrivate.h>
#include <objc/objc-api.h>

@implementation SplayTree

+ initialize
{
  if (self == [SplayTree class])
    [self setVersion:-1];	/* alpha release */
  return self;
}

- splayNode: aNode
{
  [self notImplemented:_cmd];
  return self;
}

- addElement: (elt)newElement
{
  [self sortAddElement:newElement];
  while (newElement.id_u != _contents_root)
    [self splayNode:newElement.id_u];
  return self;
}

- (elt) removeElement: (elt)anElement
{
  [self notImplemented:_cmd];
  return anElement;
}

@end
