/* Interface to TMConnectionObserver class.
   Written by Tiggr <tiggr@es.ele.tue.nl> and Michael <michael@thi.nl>

   Copyright (C) 1994, 1995 Pieter J. Schoenmakers and Michael L.H. Brouwer.
   All rights reserved.

   This file is part of RUNNER.

   RUNNER is free software; you can redistribute it and/or modify it
   under the terms of the GNU Library General Public License as
   published by the Free Software Foundation; either version 2, or (at
   your option) any later version.

   RUNNER is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Library General Public
   License for more details.

   You should have received a copy of the GNU Library General Public
   License along with RUNNER; see the file COPYING.LIB.  If not, write
   to the Free Software Foundation, 59 Temple Place - Suite 330, Boston,
   MA 02111-1307, USA.

   $Id: TMConnectionObserver.h,v 1.1 1995/08/25 14:53:11 tiggr Exp $  */

#import <objc/Object.h>
#import <machkit/senderIsInvalid.h>

/* Nothing fancy like NXLogError.  */
void LogError (const char *fmt, ...);

@protocol TMProxyDeath

-(void) proxyDied: (id) proxy;

@end

@class HashTable;

@interface TMConnectionObserver: Object <NXSenderIsInvalid>
{
  HashTable *proxies;
}

-(void) registerProxy: (id) proxy forLocal: (id <TMProxyDeath>) local;

-(void) unregisterProxy: (id) proxy;

@end
